Dim g_NumCellsSampled, g_NumcellsAdaptStamp, g_CursampNum, g_weedfound

'****************************************************************************************************************************

Sub CreatePoint(strLname)
If GPS.Isopen Then
	If GPS.Isvalidfix then
	
		dim l
		l = ReadConfig(strLname)
		If map.layers(l).CanEdit then

			map.layers(l).Editable = True

		Else

			Msgbox "Cannot edit " &  l, vbinformation, "Aborting"
			Exit Sub
		End if

		application.executecommand("addgpspoint")
	Else
		Msgbox "There is currently no valid GPS postion!", vbinformation, "Cannot Continue"
	End if
Else
	If Msgbox("The GPS is not active, would you like to activate it?", vbyesno + vbinformation, "Activate GPS") = vbyes then
		GPS.Open
		Msgbox "Please add point again when GPS has valid fix!", vbinformation, "GPS Open"
	End if
End if
End Sub

'****************************************************************************************************************************
Sub Grid_Load
dim objpg, objfrm
set objfrm = Thisevent.object
set objpg = Thisevent.object.pages("page1")
set objfrm = objpg.Parent

If Cint(g_NumcellsAdaptStamp + 1) > Cint(ReadConfig("Amax")) Then
	If msgbox("The maximum adaptive sampling units has been reached, do you want to continue?", vbyesno, "Amax Reached") = vbno then 
	objfrm.Close(False)
	Call Amax_Clear
	exit sub
	End if
End if

If Cint(g_NumCellsSampled + 1) > Cint(ReadConfig("Smax")) Then
	if msgbox ("Maximum sampling units has been reached, do you want to continue?", vbyesno, "Smax Reached") = vbno Then 
	objfrm.Close(False)
	Call Smax_Clear
	Exit Sub
	End if
End if


'If objfrm.Mode = 2 Then
'	If Not Len(objpg.Controls("cCode").Value) > 0 then
'		objpg.Controls("cCode").Value = 1
'	End if
'	if not objpg.Controls("cCode").Value = 1 Then
'		objpg.Controls("cCode").Value = 2
'	End if
'Elseif objfrm.Mode = 3 Then
'	objpg.Controls("cCode").Value = 1
'End if
dim i, plist
plist = Split(ReadConfig("TargetSpecies"), ",")
for i = 0 to Ubound(plist)
	objpg.Controls("TARGETSPEC").Additem Trim(plist(i)), Trim(plist(i))
Next
'objpg.Controls("plotID").Value = ReadConfig("CurrentPlotID")
objpg.Controls("TARGETSPEC").Listindex = Getindex(objpg.Controls("TARGETSPEC"), ReadConfig("CurrentTargetSpecies"))
objpg.Controls("Cellssamp").Value = g_NumCellsSampled
objpg.Controls("CellsASamp").Value = g_NumcellsAdaptStamp
'set objrs = nothing
set objpg = nothing

End Sub

'****************************************************************************************************************************


Sub Grid_OK
dim objpg
set objpg = Thisevent.object.pages("page1")
If not Len(objpg.Controls("cCode").Value) > 0 then objpg.Controls("cCode").Value =0
	If objpg.Controls("cCode").Value = 2 Then 'if the cell has already been updated!!
		If objpg.Controls("cboscode").Value = 2 Then 'Not Sampled
			If not g_NumcellsAdaptStamp < 1 Then
				g_NumcellsAdaptStamp = g_NumcellsAdaptStamp - 1
			End if
			If not g_NumCellsSampled < 1 Then
				g_NumCellsSampled = g_NumCellsSampled - 1
			End if		
			objpg.Controls("cCode").Value = 0
		End if
		If objpg.Controls("cboscode").Value = 1 Then 'Sampled/Present
			g_NumcellsAdaptStamp = g_NumcellsAdaptStamp + 1
			g_weedfound = true
		End if	

	Else
		If CInt(objpg.Controls("cboscode").Value) = -9 Then 'Not Sampleable
				if g_weedfound = true Then
					g_NumcellsAdaptStamp = g_NumcellsAdaptStamp + 1
				End if	
				g_NumCellsSampled = g_NumCellsSampled + 1
		End if

		If objpg.Controls("cboscode").Value = 1 Then 'Sampled/Present
				g_NumcellsAdaptStamp = g_NumcellsAdaptStamp + 1
				g_NumCellsSampled = g_NumCellsSampled + 1
				g_weedfound = true
		End if
		If objpg.Controls("cboscode").Value = 0 Then'Sampled/Absent
				if g_weedfound = true Then
					g_NumcellsAdaptStamp = g_NumcellsAdaptStamp + 1
				End if
				g_NumCellsSampled = g_NumCellsSampled + 1

		End if
	End if

If objpg.Controls("cboscode").Value = 1 Then
	'msgbox "running sample"
	Call Runsample(objpg.Controls("cboPatch_Pattern").Value)
End if
set objrs = Nothing
set objpg = nothing
End Sub
'****************************************************************************************************************************

Sub Plot_Load
dim objpg, objfrm, objRs, objshp
set objfrm = Thisevent.object
set objpg = Thisevent.object.pages("page1")
set objfrm = objpg.Parent
If not Map.SelectionLayer is Nothing Then
	Set objRs = Map.SelectionLayer.Records
	objRS.Bookmark =  Thisevent.Bookmark
	set objshp = objRs.Fields.Shape
Else
	if Gps.isvalidfix then
		set objshp = Application.CreateAppobject("point")
		objshp.x = GPS.X
		objshp.y = GPS.Y
	Else
		Msgbox "Cannot continue without GPS fix!", vbinformation, "Aborting"
		Exit Sub
	End if
	

End if
'dblX = objRS.Fields.Shape.X
'dblY = objRs.Fields.shape.Y
'GetPlotID objRs.Fields.Shape

If objfrm.Mode = 2 Then
	If Not Len(objpg.Controls("cCode").Value) > 0 then
		objpg.Controls("cCode").Value = 1
	End if
	if not objpg.Controls("cCode").Value = 1 Then
		objpg.Controls("cCode").Value = 2
	End if
Elseif objfrm.Mode = 3 Then
	objpg.Controls("cCode").Value = 1

'End if
	dim slist1,slist2,  i, plist
	slist1 = Split(ReadConfig("Surveyor1"), ",")
	for i = 0 to UBound(slist1)
		objpg.Controls("cmboS1").Additem Trim(slist1(i)), Trim(slist1(i))
	Next 
	slist2 = Split(ReadConfig("Surveyor2"), ",")
	for i = 0 to UBound(slist2)
		objpg.Controls("cmboS2").Additem Trim(slist2(i)), Trim(slist2(i))
	Next 
	plist = Split(ReadConfig("TargetSpecies"), ",")
	for i = 0 to Ubound(plist)
		objpg.Controls("TARGETSPEC").Additem Trim(plist(i)), Trim(plist(i))
	Next
	objpg.Controls("plotID").Value = GetPlotID(objshp)
	objpg.Controls("Smax").Value = ReadConfig("Smax")
	objpg.Controls("Amax").Value = ReadConfig("Amax")
	''objpg.Controls("sO").Value = ReadConfig("sO")
	objpg.Controls("Psp").Value = ReadConfig("Psp")
	objpg.Controls("chkArnda").Value = ReadConfig("AllowRand")

	objpg.Controls("cmboS1").Listindex = Getindex(objpg.Controls("cmboS1"),objpg.Controls("cmboS1").Field.Value )
	objpg.Controls("cmboS2").Listindex = Getindex(objpg.Controls("cmboS2"), objpg.Controls("cmboS2").Field.Value)
	objpg.Controls("TARGETSPEC").Listindex = Getindex(objpg.Controls("TARGETSPEC"), objpg.Controls("TARGETSPEC").Field.Value)
	If objpg.Controls("chkArnda").Value = True Then
		objpg.Controls("chkCRA").Enabled = True
		objpg.Controls("chkCRA").Value = ReadConfig("ConstRand")
	Else
		objpg.Controls("chkCRA").Enabled = False
		objpg.Controls("chkCRA").Value = False
	End if
End if
set objrs = nothing
set objshp = Nothing
set objpg = nothing
End Sub

'****************************************************************************************************************************

Sub Plot_OK
dim objpg, i, slist1, slist2, plist
set objpg = Thisevent.object.pages("page1")
WriteConfig"CurrentSurveyor1",objpg.Controls("cmboS1").Value 
WriteConfig"CurrentSurveyor2",objpg.Controls("cmboS2").Value 
WriteConfig"CurrentPlotID",objpg.Controls("plotID").Value 
WriteConfig"CurrentTargetSpecies",objpg.Controls("TARGETSPEC").Value 
for i = 0 to objpg.controls("cmboS1").ListCount
	objpg.controls("cmboS1").listindex = i
	if Not Len(slist1) > 0 Then
		slist1 = objpg.controls("cmboS1").Value
	Else
		slist1 = slist1 & "," & objpg.controls("cmboS1").Value
	End if

Next

for i = 0 to objpg.controls("cmboS2").ListCount
	objpg.controls("cmboS2").listindex = i
	if Not Len(slist2) > 0 Then
		slist2 = objpg.controls("cmboS2").Value
	Else
		slist2 = slist2 & "," & objpg.controls("cmboS2").Value
	End if

Next

for i = 0 to objpg.controls("TARGETSPEC").ListCount
	objpg.controls("TARGETSPEC").listindex = i
	if Not Len(plist) > 0 Then
		plist = objpg.controls("TARGETSPEC").Value
	Else
		plist = plist & "," & objpg.controls("TARGETSPEC").Value
	End if

Next
WriteConfig"TargetSpecies", plist
WriteConfig"Surveyor1", slist1
WriteConfig"Surveyor2", slist2
WriteConfig"Smax",  objpg.Controls("Smax").Value 
WriteConfig"Amax",objpg.Controls("Amax").Value 
'WriteConfig"sO",  objpg.Controls("sO").Value 
WriteConfig"Psp",objpg.Controls("Psp").Value 
If objpg.Controls("chkArnda").Value = True Then
	WriteConfig"AllowRand",  "True"
Else
	WriteConfig"AllowRand",  "False"
End if
If objpg.Controls("chkCRA").Value = True Then
	WriteConfig"ConstRand","True"
Else
	WriteConfig"ConstRand","False"
End if
g_NumCellsSampled = 0
g_NumcellsAdaptStamp = 0
g_CursampNum = 0 
g_weedfound = False
set objpg = nothing
End Sub

'****************************************************************************************************************************


Sub addtolist
dim objpg, strVal, strName
set objpg = Thisevent.object.Parent
strName = Replace(Thisevent.object.Name, "btn", "")
strVal = Application.InputBox("Enter Name to add", "Name")
if Len(strVal) > 0 Then
	objpg.Controls(strName).Additem strVal, strVal
End if
set objpg = Nothing
End sub



'****************************************************************************************************************************

Function GetAppletPath
dim i, rpl
If Len(Preferences.Properties("AppletsPath")) > 0 Then
	GetAppletPath = Preferences.Properties("AppletsPath")
Else
	i = InstrRev(Preferences.Properties("SystemPath"), "\") + 1
	rpl =Mid(Preferences.Properties("SystemPath"), i)
	GetAppletPath =Replace(Preferences.Properties("SystemPath"), rpl, "Applets")
End if

End Function

'****************************************************************************************************************************


Function ReadConfig(key)
Dim fso, i, cLine
set fso = Application.CreateAppObject("File") 
If fso.exists(GetAppletPath & "\WebSampling.config") Then
	fso.Open GetAppletPath & "\WebSampling.config", 1
	Do while fso.EOF = False
		cLine = fso.ReadLine
		If Len(cLine) > 0 Then
			i = Instr(cline, "=") - 1
			If Left(cline, i) = key Then
				ReadConfig = Mid(cline, i + 2) &""
			End if
		End If
	Loop
Else
Msgbox "Cannot read config file from " & GetAppletPath & "\WebSampling.config", vbcritical, "Aborting"
End if

Set fso = Nothing
End function

'****************************************************************************************************************************

Function WriteConfig(subk, val)
Dim fso, bGotmain, i, MyArray, x, cLine, bGotSub
Redim MyArray(0)
set fso = Application.CreateAppObject("File") 
If fso.exists(GetAppletPath & "\WebSampling.config") Then 
	fso.Open GetAppletPath & "\WebSampling.config", 1
	Do while fso.EOF = False
		cLine = fso.ReadLine
		If Len(cline) > 0 Then
			i = Instr(cline, "=") -1
			If i > 0 Then
				If bGotSub = False Then
					If Left(cline, i) = subk Then
						bGotSub = True
						MyArray(x) = Left(cline, i + 1) & val
					Else
						MyArray(x) = cLine
					End if
				Else
					MyArray(x) = cLine
				End if
			End if
			x = x + 1
			Redim preserve MyArray(x)
		End if
	Loop
If bGotmain = True and bGotSub = False Then
	MyArray(x) = subk & "=" & val
End if

fso.Close
fso.Open GetAppletPath & "\WebSampling.config", 2
Dim k
for k = 0 to Ubound(MyArray)
	fso.WriteLine MyArray(k)

Next
fso.Close
Else ' Use Registry

Msgbox "Cannot read config file from " & GetAppletPath & "\WebSampling.config", vbcritical, "Aborting"
End if
Set fso = Nothing
End function

'**************************************************************************************************************************************************************

Function GetIndex (cntrl, value)
dim i

For i = 0 to cntrl.ListCount
	cntrl.listindex = i
	if value = cntrl.Value Then
		GetIndex = i
		Exit function
	end if

Next
GetIndex = -1
End Function

'**************************************************************************************************************************************************************


Sub UpdateCurrentCell
If GPS.Isvalidfix Then
	dim l
	for each l in Map.Layers
		If l.canedit then
			If Ucase(l.name) = Ucase(ReadConfig("GridLayer")) Then
				l.editable = true
			Else
				l.editable = false
			End if
		End if
	Next
	
	If Map.SelectXY(GPS.X, GPS.Y) Then
		application.executecommand("featureproperties")
	Else
		msgbox "Cannot find grid cell in current GPS location!", vbinformation, "No Selection"
	End if
Else

	msgbox "Cannot update grid cell, no GPS fix!", vbinformation, "Aborting"

End if
application.executecommand("clearselected")
Map.Layers(ReadConfig("GridLayer")).Editable = False

End Sub




'**************************************************************************************************************************************************************

Sub WritePlotApl(path, strname)
Dim fso
set fso = Application.CreateAppObject("file")
Call fso.Open (path, 2)
fso.WriteLine("<ArcPad>")
fso.WriteLine("	<LAYER name="& chr(34) & strname & chr(34) &">")
fso.WriteLine("		<SYMBOLOGY>")
fso.WriteLine("			<SIMPLELABELRENDERER visible=""false"" field=""SURVEYOR1"" rotationfield="""" expression="""" language="""">")
fso.WriteLine("				<TEXTSYMBOL font=""Arial"" charset="""" fontsize=""8.2"" fontstyle=""regular"" fontcolor=""Black""/>")
fso.WriteLine("			</SIMPLELABELRENDERER>")
fso.WriteLine("			<SIMPLERENDERER>")
fso.WriteLine("				<SIMPLEMARKERSYMBOL color=""0,141,148"" width=""4"" outlinewidth=""1""/>")
fso.WriteLine("			</SIMPLERENDERER>")
fso.WriteLine("		</SYMBOLOGY>")
fso.WriteLine("		<FORMS>")
fso.WriteLine("			<EDITFORM caption=""plot"" width=""130"" height=""130"" attributespagevisible=""false"" name=""EDITFORM"" onload=""Application.Applets(&quot;weedsamp&quot;).Execute(&quot;Plot_Load&quot;)"" onok=""Application.Applets(&quot;weedsamp&quot;).Execute(&quot;Plot_OK&quot;)"">")
fso.WriteLine("				<PAGE name=""PAGE1"" caption=""Page 1"" sip=""false"">")
fso.WriteLine("					<LABEL name=""lSmax"" x=""2"" y=""66"" width=""25"" height=""9"" caption=""Smax"" tooltip="""" group=""true"" border=""false""/>")
fso.WriteLine("					<LABEL name=""lAmax"" x=""64"" y=""66"" width=""25"" height=""9"" caption=""Amax"" tooltip="""" group=""true"" border=""false""/>")
''fso.WriteLine("					<LABEL name=""lsO"" x=""2"" y=""82"" width=""19"" height=""9"" caption=""s0"" tooltip="""" group=""true"" border=""false""/>")
fso.WriteLine("					<EDIT name=""Smax"" x=""28"" y=""66"" width=""30"" height=""12"" defaultvalue="""" tooltip="""" tabstop=""true"" border=""true"" sip=""false"" field=""""/>")
fso.WriteLine("					<EDIT name=""Amax"" x=""92"" y=""66"" width=""30"" height=""12"" defaultvalue="""" tooltip="""" tabstop=""true"" border=""true"" sip=""false"" field=""""/>")
''fso.WriteLine("					<EDIT name=""sO"" x=""28"" y=""82"" width=""30"" height=""12"" defaultvalue="""" tooltip="""" tabstop=""true"" border=""true"" sip=""false"" field=""""/>")
fso.WriteLine("					<LABEL name=""pid"" x=""2"" y=""3"" width=""53"" height=""9"" caption=""Plot ID"" tooltip="""" group=""true"" border=""false""/>")
fso.WriteLine("					<EDIT name=""plotID"" x=""60"" y=""3"" width=""65"" height=""12"" defaultvalue="""" tooltip="""" tabstop=""true"" border=""true"" sip=""false"" field=""PLOTID""/>")
fso.WriteLine("					<LABEL name=""Label5"" x=""2"" y=""18"" width=""39"" height=""9"" caption=""Surveyor 1"" tooltip="""" group=""true"" border=""false""/>")
fso.WriteLine("					<COMBOBOX name=""cmboS1"" x=""60"" y=""18"" width=""65"" height=""12"" defaultvalue="""" listtable="""" listvaluefield="""" listtextfield="""" tooltip="""" tabstop=""true"" border=""false"" sip=""false"" sort=""false"" field=""SURVEYOR1""/>")
fso.WriteLine("					<LABEL name=""lbls2"" x=""2"" y=""34"" width=""41"" height=""9"" caption=""Surveyor 2"" tooltip="""" group=""true"" border=""false""/>")
fso.WriteLine("					<COMBOBOX name=""cmboS2"" x=""60"" y=""34"" width=""65"" height=""12"" defaultvalue="""" listtable="""" listvaluefield="""" listtextfield="""" tooltip="""" tabstop=""true"" border=""false"" sip=""false"" sort=""false"" field=""SURVEYOR2""/>")
fso.WriteLine("					<BUTTON name=""btnTARGETSPEC"" x=""47"" y=""49"" width=""12"" height=""12"" onclick=""Application.Applets(&quot;weedsamp&quot;).Execute(&quot;addtoList&quot;)"" caption=""+"" tooltip="""" tabstop=""true"" border=""false"" alignment=""center""/>")
fso.WriteLine("					<BUTTON onclick=""Application.Applets(&quot;weedsamp&quot;).Execute(&quot;addtoList&quot;)"" name=""btncmboS2"" x=""47"" y=""33"" width=""12"" height=""12"" caption=""+"" tooltip="""" tabstop=""true"" border=""false"" alignment=""center""/>")
fso.WriteLine("					<LABEL name=""ts"" x=""2"" y=""50"" width=""40"" height=""10"" caption=""Target Spc."" tooltip="""" group=""true"" border=""false""/>")
fso.WriteLine("					<COMBOBOX name=""TARGETSPEC"" x=""60"" y=""50"" width=""65"" height=""100"" defaultvalue="""" listtable="""" listvaluefield="""" listtextfield="""" tooltip="""" tabstop=""true"" border=""false"" sip=""false"" limittolist=""false"" sort=""false"" field=""TARGET_SPE""/>")
fso.WriteLine("					<LABEL name=""lblpsp"" x=""64"" y=""82"" width=""25"" height=""10"" caption=""Psp"" tooltip="""" group=""true"" border=""false""/>")
fso.WriteLine("					<EDIT name=""Psp"" x=""92"" y=""82"" width=""30"" height=""12"" defaultvalue="""" tooltip="""" tabstop=""true"" border=""true"" sip=""false"" field=""""/>")
fso.WriteLine("					<CHECKBOX name=""chkArnda"" x=""1"" y=""98"" width=""87"" height=""12"" defaultvalue="""" caption=""Allow Random Additions"" tooltip="""" tabstop=""true"" border=""false"" field="""" alignment=""left"" onclick=""Application.Applets(&quot;weedsamp&quot;).Execute(&quot;Rand_Click&quot;)""/>")
fso.WriteLine("					<CHECKBOX name=""chkCRA"" x=""1"" y=""114"" width=""116"" height=""12"" defaultvalue="""" caption=""Constrain Random Additions"" tooltip="""" tabstop=""true"" border=""false"" field="""" alignment=""left""/>")
fso.WriteLine("					<EDIT name=""Ccode"" x=""1"" y=""300"" width=""80"" height=""12"" defaultvalue="""" tooltip="""" tabstop=""true"" border=""true"" sip=""false"" field=""__CHGCODE""/>")
fso.WriteLine("					<BUTTON name=""btncmboS1"" x=""47"" y=""18"" width=""12"" height=""12"" onclick=""Application.Applets(&quot;weedsamp&quot;).Execute(&quot;addtoList&quot;)"" caption=""+"" tooltip="""" tabstop=""true"" border=""false"" alignment=""center""/>")
fso.WriteLine("				</PAGE>")
fso.WriteLine("				<PAGE name=""PAGE2"" caption=""Page 2"" sip=""false"">")
fso.WriteLine("					<DATETIME name=""Date1"" x=""49"" y=""2"" width=""80"" height=""14"" defaultvalue="""" tooltip="""" tabstop=""true"" border=""true"" sip=""false"" field=""GPSDATE""/>")
fso.WriteLine("					<LABEL name=""lbldt"" x=""2"" y=""2"" width=""36"" height=""10"" caption=""Date"" tooltip="""" group=""true"" border=""false""/>")
fso.WriteLine("					<EDIT name=""txtComments"" x=""2"" y=""34"" width=""123"" height=""68"" defaultvalue="""" tooltip="""" tabstop=""true"" border=""true"" sip=""false"" field=""COMMENTS"" multiline=""true"" vscroll=""true""/>")
fso.WriteLine("					<LABEL name=""lblComments"" x=""2"" y=""21"" width=""50"" height=""10"" caption=""Comments"" tooltip="""" group=""true"" border=""false""/>")
fso.WriteLine("				</PAGE>")
fso.WriteLine("			</EDITFORM>")
fso.WriteLine("		</FORMS>")
fso.WriteLine("		<QUERY where=""""/>")
fso.WriteLine("	</LAYER>")
fso.WriteLine("</ArcPad>")
fso.close
set fso = Nothing
End sub

'**************************************************************************************************************************************************************

Sub WriteGridApl(path, strname)
Dim fso
set fso = Application.CreateAppObject("file")
Call fso.Open (path, 2)
fso.WriteLine("<ArcPad>")
fso.WriteLine("	<LAYER name="& chr(34) & strname & chr(34) &">")
fso.WriteLine("		<SYMBOLOGY>")
fso.WriteLine("			<SIMPLELABELRENDERER visible=""true"" field=""Label"">")
fso.WriteLine("				<TEXTSYMBOL font=""Arial"" charset="""" fontsize=""9"" fontstyle=""bold"" fontcolor=""0,0,0"" blockout=""Yellow"" angle=""0.000000""/>")
fso.WriteLine("			</SIMPLELABELRENDERER>")
fso.WriteLine("			<VALUEMAPRENDERER lookupfield=""scode"">")
fso.WriteLine("				<EXACT value=""-1"" label=""Initial Sample Set"">")
fso.WriteLine("					<SIMPLEPOLYGONSYMBOL filltype=""solid"" filltransparency=""1"" fillcolor=""132,0,168"" boundarytype=""solid"" boundarywidth=""0.400000"" boundarycolor=""110,110,110"" boundarytransparency=""1""/>")
fso.WriteLine("				</EXACT>")
fso.WriteLine("				<EXACT value=""3"" label=""Need to Sample"">")
fso.WriteLine("					<SIMPLEPOLYGONSYMBOL filltype=""solid"" filltransparency=""1"" fillcolor=""255,170,0"" boundarytype=""solid"" boundarywidth=""0.400000"" boundarycolor=""110,110,110"" boundarytransparency=""1""/>")
fso.WriteLine("				</EXACT>")
fso.WriteLine("				<EXACT value=""-9"" label=""Not Sampleable"">")
fso.WriteLine("					<SIMPLEPOLYGONSYMBOL filltype=""solid"" filltransparency=""1"" fillcolor=""130,130,130"" boundarytype=""solid"" boundarywidth=""0.400000"" boundarycolor=""110,110,110"" boundarytransparency=""1""/>")
fso.WriteLine("				</EXACT>")
fso.WriteLine("				<EXACT value=""2"" label=""Not Sampled"">")
fso.WriteLine("					<SIMPLEPOLYGONSYMBOL filltype=""solid"" filltransparency=""1"" fillcolor=""190,232,255"" boundarytype=""solid"" boundarywidth=""0.400000"" boundarycolor=""110,110,110"" boundarytransparency=""1""/>")
fso.WriteLine("				</EXACT>")
fso.WriteLine("				<EXACT value=""0"" label=""Sampled/Absent"">")
fso.WriteLine("					<SIMPLEPOLYGONSYMBOL filltype=""solid"" filltransparency=""1"" fillcolor=""255,0,0"" boundarytype=""solid"" boundarywidth=""0.400000"" boundarycolor=""110,110,110"" boundarytransparency=""1""/>")
fso.WriteLine("				</EXACT>")
fso.WriteLine("				<EXACT value=""1"" label=""Sampled/Present"">")
fso.WriteLine("					<SIMPLEPOLYGONSYMBOL filltype=""solid"" filltransparency=""1"" fillcolor=""56,168,0"" boundarytype=""solid"" boundarywidth=""0.400000"" boundarycolor=""110,110,110"" boundarytransparency=""1""/>")
fso.WriteLine("				</EXACT>")
fso.WriteLine("				<OTHER label=""&lt;all other values&gt;"">")
fso.WriteLine("					<SIMPLEPOLYGONSYMBOL filltype=""solid"" filltransparency=""1"" fillcolor=""238,186,245"" boundarytype=""solid"" boundarywidth=""0.400000"" boundarycolor=""110,110,110"" boundarytransparency=""1""/>")
fso.WriteLine("				</OTHER>")
fso.WriteLine("			</VALUEMAPRENDERER>")
fso.WriteLine("		</SYMBOLOGY>")
fso.WriteLine("		<FORMS>")
fso.WriteLine("			<EDITFORM caption=""surveyGrid"" width=""130"" height=""130"" name=""EDITFORM"" onload=""Application.Applets(&quot;weedsamp&quot;).Execute(&quot;Grid_Load&quot;)"" onok=""Application.Applets(&quot;weedsamp&quot;).Execute(&quot;Grid_OK&quot;)"" picturepagevisible=""false"" geographypagevisible=""false"">")
fso.WriteLine("				<PAGE name=""page1"" onvalidate=""Application.Applets(&quot;weedsamp&quot;).Execute(&quot;Grid_Validate&quot;)"" caption=""Page 1"">")
fso.WriteLine("					<LABEL name=""lblscode"" x=""2"" y=""2"" width=""60"" height=""12"" caption=""Status"" tooltip="""" border=""false""/>")
fso.WriteLine("					<COMBOBOX name=""cboscode"" x=""64"" y=""2"" width=""60"" height=""12"" defaultvalue="""" listtable="""" listvaluefield="""" listtextfield="""" onselchange=""Application.Applets(&quot;weedsamp&quot;).Execute(&quot;GridStatus_Change&quot;)"" tooltip="""" tabstop=""true"" border=""true"" sip=""false"" sort=""false"" field=""SCODE"">")
fso.WriteLine("						<LISTITEM text=""Need to Sample"" value=""3""/>")
fso.WriteLine("						<LISTITEM text=""Sampled/Absent"" value=""0""/>")
fso.WriteLine("						<LISTITEM text=""Sampled/Present"" value=""1""/>")
fso.WriteLine("						<LISTITEM text=""Not Sampleable"" value=""-9""/>")
fso.WriteLine("						<LISTITEM text=""Not Sampled"" value=""2""/>")
fso.WriteLine("						<LISTITEM text=""Initial Sample Set"" value=""-1""/>")
fso.WriteLine("					</COMBOBOX>")
fso.WriteLine("					<LABEL name=""lbltarget_species"" x=""2"" y=""17"" width=""60"" height=""12"" caption=""Target Spc."" tooltip="""" border=""false""/>")
fso.WriteLine("					<COMBOBOX name=""TARGETSPEC"" x=""64"" y=""17"" width=""60"" height=""12"" defaultvalue="""" listtable="""" listvaluefield="""" listtextfield="""" tooltip="""" tabstop=""true"" border=""true"" sip=""false"" sort=""false"" field=""TARGET_SPE""/>")
fso.WriteLine("					<LABEL name=""lblPercent_Cover"" x=""2"" y=""32"" width=""60"" height=""12"" caption=""Per. Cover"" tooltip="""" border=""false""/>")
fso.WriteLine("					<EDIT name=""txtPercent_Cover"" x=""64"" y=""32"" width=""60"" height=""12"" defaultvalue="""" tooltip="""" tabstop=""true"" border=""true"" field=""PERCENT_CO""/>")
fso.WriteLine("					<LABEL name=""lblPatch_Density"" x=""2"" y=""47"" width=""60"" height=""12"" caption=""Patch Density"" tooltip="""" border=""false""/>")
fso.WriteLine("					<COMBOBOX name=""cboPatch_Density"" x=""64"" y=""47"" width=""60"" height=""12"" defaultvalue="""" listtable="""" listvaluefield="""" listtextfield="""" tooltip="""" tabstop=""true"" border=""true"" sip=""false"" sort=""false"" field=""PATCH_DENS"">")
fso.WriteLine("						<LISTITEM value=""&lt;0-1"" text=""&lt;0-1""/>")
fso.WriteLine("						<LISTITEM value=""1-11"" text=""1-11""/>")
fso.WriteLine("						<LISTITEM value=""12-32"" text=""12-32""/>")
fso.WriteLine("						<LISTITEM value=""33-100"" text=""33-100""/>")
fso.WriteLine("						<LISTITEM value=""101-316"" text=""101-316""/>")
fso.WriteLine("						<LISTITEM value=""317-1000"" text=""317-1000""/>")
fso.WriteLine("						<LISTITEM value=""&gt;1000"" text=""&gt;1000""/>")
fso.WriteLine("					</COMBOBOX>")
fso.WriteLine("					<LABEL name=""lblPatch_Pattern"" x=""2"" y=""62"" width=""60"" height=""12"" caption=""Patch Pattern"" tooltip="""" border=""false""/>")
fso.WriteLine("					<COMBOBOX name=""cboPatch_Pattern"" x=""64"" y=""62"" width=""60"" height=""12"" defaultvalue="""" listtable="""" listvaluefield="""" listtextfield="""" tooltip="""" tabstop=""true"" border=""true"" sip=""false"" sort=""false"" field=""PATCH_PATT"">")
fso.WriteLine("						<LISTITEM value=""ind/scattered plants"" text=""ind/scattered plants""/>")
fso.WriteLine("						<LISTITEM value=""discrete patches"" text=""discrete patches""/>")
fso.WriteLine("						<LISTITEM value=""interconnected patches"" text=""interconnected patches""/>")
fso.WriteLine("					</COMBOBOX>")
fso.WriteLine("					<EDIT name=""Ccode"" x=""1"" y=""300"" width=""80"" height=""12"" defaultvalue="""" tooltip="""" tabstop=""true"" border=""true"" sip=""false"" field=""__CHGCODE""/>")
fso.WriteLine("					<LABEL name=""lblLHV"" x=""2"" y=""77"" width=""60"" height=""12"" caption=""LHV"" tooltip="""" border=""false""/>")
fso.WriteLine("					<EDIT name=""txtLHV"" x=""64"" y=""77"" width=""60"" height=""12"" defaultvalue="""" tooltip="""" tabstop=""true"" border=""true"" field=""LHV""/>")
fso.WriteLine("					<LABEL name=""lblPLOT_ID"" x=""2"" y=""92"" width=""60"" height=""12"" caption=""PLOT ID"" tooltip="""" border=""false""/>")
fso.WriteLine("					<EDIT name=""plotID"" x=""64"" y=""92"" width=""60"" height=""12"" defaultvalue="""" tooltip="""" tabstop=""true"" border=""true"" field=""PLOT_ID""/>")
fso.WriteLine("					<EDIT name=""Cellssamp"" x=""1"" y=""110"" width=""27"" height=""17"" defaultvalue="""" tooltip="""" tabstop=""true"" border=""true"" readonly=""true"" sip=""false"" field="""" fontsize=""12"" fontstyle=""bolditalic""/>")
fso.WriteLine("					<EDIT name=""CellsASamp"" x=""31"" y=""110"" width=""27"" height=""17"" defaultvalue="""" tooltip="""" tabstop=""true"" border=""true"" readonly=""true"" sip=""false"" field="""" fontsize=""12"" fontstyle=""bolditalic""/>")
fso.WriteLine("				</PAGE>")
fso.WriteLine("			</EDITFORM>")
fso.WriteLine("		</FORMS>")
fso.WriteLine("	</LAYER>")
fso.WriteLine("</ArcPad>")
fso.close
set fso = Nothing
End sub

'**************************************************************************************************************************************************************

Sub LoadApls
dim l, nl, lName
dim fpath, fso
set fso = Application.Createappobject("file")

for each l in map.layers
lName = l.name
fpath = l.filepath

	if l.comments <> "updated" Then
		If UCase(lName) = Ucase(Readconfig("GridLayer")) Then
			Call WriteGridAPL(Replace(fpath, ".shp", ".apl"), replace(lName, ".shp", ""))
			map.layers.remove(lName)
			set nl = map.addlayerfromfile(fpath)
			nl.Comments = "updated"
		End if
		If UCase(lName) = Ucase(Readconfig("PlotLayer")) Then
			Call WritePlotAPL(Replace(fpath, ".shp", ".apl"), replace(lName, ".shp", ""))
			map.layers.remove(lName)
			set nl = map.addlayerfromfile(fpath)
			nl.Comments = "updated"
		End if
	end if
Next
dim cL
set cL = Map.Layers(Readconfig("GridLayer"))
if cl is nothing then
	console.print "Missing Grid Layer in current map"
End if
set cL = Map.Layers(Readconfig("PlotLayer"))
if cl is nothing then
	console.print "Missing Plot Layer in current map"
End if
map.properties("SelectionColor") = apRed
map.save
set cL = Nothing
set fso = Nothing
set nl = Nothing
End Sub



'**************************************************************************************************************************************************************

Sub Runsample(strPatt)
dim objrs, findBuff, linkprob, rNum, row, plotID, plotCount, curFID
set objrs = Map.SelectionLayer.Records
objrs.bookmark = map.selectionbookmark
row = objrs.Fields("row").Value
plotID = objrs.Fields("PLOT_ID").Value
plotCount = objrs.Fields("PlotCount").Value
curFID = objrs.Fields("OBJECTID").Value
if strPatt = "ind/scattered plants" Then
	linkprob = Cdbl(Readconfig("Psp"))
Else
	linkprob = Cdbl(objrs.fields("LHV").Value / 9)
End if

'rNum = rnd

set findBuff = Application.CreateAppObject("ellipse")
findBuff.extent = objrs.fields.shape.centroid.Buffer(10).extent
Do
	FromBookMark = objrs.Find("[SCODE] = ""2"" OR [SCODE] = ""-1""" ,findBuff.extent, FromBookMark)
	If FromBookmark > 0 Then
		If objrs.Fields("OBJECTID").Value <> curFID Then
		'msgbox "here"
			rNum = rnd
			if rNum <= linkProb Then
				objrs.Fields("label").Value = CStr(g_CursampNum)
				if objrs.Fields("scode").Value = -1 Then
					objrs.Fields("Status").Value = "Initial Sample Set"
				End if
				objrs.Fields("scode").Value = 3
			Else
				If Readconfig("AllowRand") = "True" Then
					If ReadConfig("ConstRand") = "True" Then
						Call ChooseRandom(objrs, true, row, plotID, plotCount)

					Else
						Call ChooseRandom(objrs, false, "", plotID, plotCount)	

					End if
				End if
			End if
			objrs.Update
		End if
	End if
Loop While FromBookMark <> 0   
g_CursampNum = g_CursampNum + 1
set objrs = Nothing

End Sub

'**************************************************************************************************************************************************************

Function ChooseRandom(rs, bval, prow, pID, pCt)
dim sBookMark, rcount, min, max, Rowrand
If bval = true Then
	'rcount = 0
	'Do
	'	sBookMark = rs.Find("[row] = " & prow & " AND [PLOT_ID] = " & pID & "" ,, sBookMark)
	'	rcount = rcount + 1
	'Loop While sBookMark <> 0
	
	max=pCt * 0.01
	min=1
	Rowrand = (Int((max-min+1)*Rnd+min))	
	rcount = 0
	Do
		sBookMark = rs.Find("[PLOT_ID]=""" & pID & """ AND [row]=""" & prow & """ AND ([SCODE]=""2"" OR [SCODE]=""-1"")",, sBookMark)
		rcount = rcount + 1
		'msgbox rcount & " - " & rowrand
		if rcount = Rowrand Then
'		msgbox "found"
			rs.Fields("label").Value = CStr(g_CursampNum)
			if rs.Fields("scode").Value = -1 Then
				rs.Fields("Status").Value = "Initial Sample Set"
			End if
			rs.Fields("scode").Value = 3
			rs.update
			Exit Do
		End if
	Loop While sBookMark <> 0

Else
	'rcount = 0
	'Do
	'	sBookMark = rs.Find("[PLOT_ID] = " & pID & "" ,, sBookMark)
	'	rcount = rcount + 1
	'Loop While sBookMark <> 0
	max=pCt
	min=1
	Rowrand = (Int((max-min+1)*Rnd+min))	
	rcount = 0
	Do
		sBookMark = rs.Find("[PLOT_ID]=""" & pID & """ AND ([SCODE]=""2"" OR [SCODE]=""-1"")" ,, sBookMark)
		rcount = rcount + 1
		if rcount = rowrand Then
			rs.Fields("label").Value = CStr(g_CursampNum)
			if rs.Fields("scode").Value = -1 Then
				rs.Fields("Status").Value = "Initial Sample Set"
			End if			
			rs.Fields("scode").Value = 3
			rs.update
			Exit Do
		End if		
	Loop While sBookMark <> 0
	
'	max=rs.recordcount
'	min=1
'	rs.bookmark = (Int((max-min+1)*Rnd+min))
'	rs.Fields("label").Value  = "1"

End if

End Function

'**************************************************************************************************************************************************************


Function GetPlotID(pPoint) 
dim objRs, i, sBookMark
set objRs = Map.Layers(Readconfig("GridLayer")).Records
Do
	sBookMark = objRs.Find("[PLOT_ID] <>""""" ,Application.Map.Extent , sBookMark)
	If objRs.Fields.Shape.IsPointin(pPoint) Then
		GetPlotID = objRS.Fields("PLOT_ID").Value
		Exit Function
	End if

Loop While sBookMark <> 0

GetPlotID = ""
set pPoint = Nothing
set objRS = Nothing

End function

'**************************************************************************************************************************************************************

Function Grid_Validate
Dim objPg
Set objPg = Thisevent.object
If objPg.Controls("cboscode").Value = 1 Then
	If Not Len(objPg.Controls("cboPatch_Pattern")) > 0 Then
		ThisEvent.Result = False             
		ThisEvent.MessageText = "Please enter a value for Patch Pattern"
		ThisEvent.MessageType = 48
	End if	
	If Not Len(objPg.Controls("cboPatch_Density")) > 0 Then
		ThisEvent.Result = False             
		ThisEvent.MessageText = "Please enter a value for Patch Density"
		ThisEvent.MessageType = 48
	End if
	If Not objPg.Controls("txtPercent_Cover") > 0 Then
		ThisEvent.Result = False             
		ThisEvent.MessageText = "Please enter a value greater than zero for Percent Cover"
		ThisEvent.MessageType = 48
	End if	
	If Not Len(objPg.Controls("TARGETSPEC")) > 0 Then
		ThisEvent.Result = False             
		ThisEvent.MessageText = "Please enter a value for Target Species"
		ThisEvent.MessageType = 48
	End if
set objpg = Nothing
End if


set objPg = Nothing

End Function


'**************************************************************************************************************************************************************
Function GridStatus_Change
dim val, objpg
val = thisevent.object.value
set objpg = thisevent.object.parent
If val <> 1 Then
	objpg.Controls("txtPercent_Cover").value = 0
	objpg.Controls("cboPatch_Density").listindex  = -1
	objpg.Controls("cboPatch_Pattern").listindex = -1
End if
set objpg = Nothing
End Function

'**************************************************************************************************************************************************************

Sub Amax_Clear
dim objRs, i, sBookMark
set objRs = Map.Layers(Readconfig("GridLayer")).Records
Do
	sBookMark = objRs.Find("[PLOT_ID]=""" & Readconfig("CurrentPlotID") & """" , , sBookMark)
	If objRs.Fields("scode").Value = 3 Then
					
		If objRs.Fields("Status").Value = "Initial Sample Set" Then
			objRs.Fields("scode").Value = -1
		Else
			objRs.Fields("scode").Value = 2
		End if
		
	End if
	objRs.Fields("label").Value = ""
Loop While sBookMark <> 0

objRs.update
g_NumcellsAdaptStamp = 0
g_CursampNum = 0
g_weedfound = false
set pPoint = Nothing
set objRS = Nothing

End Sub

'**************************************************************************************************************************************************************

Sub Smax_Clear
dim objRs, i, sBookMark
set objRs = Map.Layers(Readconfig("GridLayer")).Records
Do
	sBookMark = objRs.Find("[PLOT_ID]=""" & Readconfig("CurrentPlotID") & """" , , sBookMark)
	If objRs.Fields("scode").Value = 3 Then
		If objRs.Fields("Status").Value = "Initial Sample Set" Then
			objRs.Fields("scode").Value = -1
		Else
			objRs.Fields("scode").Value = 2
		End if
		
	End if
	objRs.Fields("label").Value = ""
Loop While sBookMark <> 0

objRs.update
g_CursampNum = 0
g_NumCellsSampled = 0
g_NumcellsAdaptStamp = 0
g_weedfound = false
set pPoint = Nothing
set objRS = Nothing

End Sub
'**************************************************************************************************************************************************************

Function Rand_Click
dim objpg
set objpg = Thisevent.object.parent
if thisevent.object.value = True then
	objpg.Controls("chkCRA").Enabled = True
Else
	objpg.Controls("chkCRA").Enabled = False
	objpg.Controls("chkCRA").Value = False
End if

set objpg = Nothing
End Function


'**************************************************************************************************************************************************************

Sub FeatChanged
If Ucase(map.SelectionLayer.Name) = Ucase(ReadConfig("GridLayer")) Then
	dim objrs
	set objrs = Map.SelectionLayer.Records
	objrs.Bookmark = Map.Selectionbookmark
	'msgbox objrs.fields("__CHGCODE").Value 
	if objrs.fields("SCODE").Value = 2 Then
		objrs.fields("__CHGCODE").Value = 0
		objrs.fields("label").Value = ""
	Elseif objrs.fields("SCODE").Value = -1 Then
		objrs.fields("__CHGCODE").Value = 0
		objrs.fields("label").Value = ""
	Else
		objrs.fields("__CHGCODE").Value = 2
	End if
	objrs.Update
	set objrs = Nothing
End if
End Sub

'**************************************************************************************************************************************************************

Sub resetT
Applets("weedsamp").Forms("frmresetT").Show


End Sub

'**************************************************************************************************************************************************************

Sub frmresetT_Open
dim objpg 
set objpg = Thisevent.object.pages("Page1")
objpg.controls("txtcurrentsmax").Value = g_NumCellsSampled
objpg.controls("txtcurrentamax").Value = g_NumcellsAdaptStamp
objpg.controls("txtcurrentlabel").Value = g_CursampNum
If g_weedfound = True Then
	objpg.controls("cmboWeedFound").Listindex = 0
Else
	objpg.controls("cmboWeedFound").Listindex = 1
End if
set objpg = Nothing
End Sub

'**************************************************************************************************************************************************************

Sub frmresetT_OK
dim objpg
set objpg = Thisevent.object
If Not Isnumeric(objPg.Controls("txtcurrentsmax").Value) Then
	ThisEvent.Result = False             
	ThisEvent.MessageText = "Please enter a number for Smax"
	ThisEvent.MessageType = 48
	exit sub
End if
If Not objPg.Controls("txtcurrentsmax").Value => 0 Then
	ThisEvent.Result = False             
	ThisEvent.MessageText = "Please enter a value for Smax"
	ThisEvent.MessageType = 48
	exit sub
End if
If Not Isnumeric(objPg.Controls("txtcurrentamax").Value) Then
	ThisEvent.Result = False             
	ThisEvent.MessageText = "Please enter a number for Amax"
	ThisEvent.MessageType = 48
	exit sub
End if
If Not objPg.Controls("txtcurrentamax").Value => 0 Then
	ThisEvent.Result = False             
	ThisEvent.MessageText = "Please enter a value for Amax"
	ThisEvent.MessageType = 48
	exit sub
End if
If Not Isnumeric(objPg.Controls("txtcurrentlabel").Value) Then
	ThisEvent.Result = False             
	ThisEvent.MessageText = "Please enter a number for Label"
	ThisEvent.MessageType = 48
	exit sub
End if
If Not objPg.Controls("txtcurrentlabel").Value => 0 Then
	ThisEvent.Result = False             
	ThisEvent.MessageText = "Please enter a value for Label"
	ThisEvent.MessageType = 48
	exit sub
End if
g_NumCellsSampled = objPg.Controls("txtcurrentsmax").Value
g_NumcellsAdaptStamp = objPg.Controls("txtcurrentamax").Value
g_CursampNum = objPg.Controls("txtcurrentlabel").Value 
g_weedfound = Cbool(objpg.controls("cmboWeedFound").Value)
set objpg = Nothing
End Sub


'**************************************************************************************************************************************************************

Sub HelpClick
Dim fso
Set fso = Application.CreateAppObject("File") 
If fso.exists(GetAppletPath & "\HELP\AdaptiveWeb_Quickstart.html") Then
	Application.Run(GetAppletPath & "\HELP\AdaptiveWeb_Quickstart.html")
Else
	ThisEvent.object.enabled = False
End If
Set fso = Nothing
End Sub